//+------------------------------------------------------------------+
//| KGB_Pivot_Daily                                                  
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Lime 

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}
int deinit()
{
   ObjectDelete("KGB");
   return(0);
}
//+------------------------------------------------------------------+
//| Draw Pivot
//+------------------------------------------------------------------+
int DrawKGB()
{
	if(ObjectFind("KGB") == -1)
		ObjectCreate("KGB",OBJ_FIBO,0,StartTime,HiPrice,StartTime,LoPrice);
	else
	{
		ObjectSet("KGB",OBJPROP_TIME2, StartTime);
		ObjectSet("KGB",OBJPROP_TIME1, StartTime);
		ObjectSet("KGB",OBJPROP_PRICE1,HiPrice);
		ObjectSet("KGB",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("KGB",OBJPROP_LEVELCOLOR,indicator_color1);
   ObjectSet("KGB",OBJPROP_FIBOLEVELS,5);
   ObjectSet("KGB",OBJPROP_FIRSTLEVEL+0,0);	ObjectSetFiboDescription("KGB",0,"Lowest 0.00 --> %$");
   ObjectSet("KGB",OBJPROP_FIRSTLEVEL+1,0.25);	ObjectSetFiboDescription("KGB",1,"Seller Balance 0.25 --> %$");
   ObjectSet("KGB",OBJPROP_FIRSTLEVEL+2,0.5);	ObjectSetFiboDescription("KGB",2,"B/S Balance 0.50 --> %$");
   ObjectSet("KGB",OBJPROP_FIRSTLEVEL+3,0.75);	ObjectSetFiboDescription("KGB",3,"Buyer Balance 0.75 --> %$");
   ObjectSet("KGB",OBJPROP_FIRSTLEVEL+4,1);	ObjectSetFiboDescription("KGB",4,"Highest 1.00 --> %$");
   ObjectSet("KGB",OBJPROP_RAY,true);
   ObjectSet("KGB",OBJPROP_BACK,true);
   }
//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+
int start()
{
	int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh (NULL,PERIOD_D1,shift);
	LoPrice		= iLow (NULL,PERIOD_D1,shift);
	StartTime	= iTime(NULL,PERIOD_D1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
	}
	Range = HiPrice-LoPrice;
	DrawKGB();

	return(0);
}
//+------------------------------------------------------------------+

