//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Fibonacci colors";
extern color MainFiboColor = RoyalBlue;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("FiboUp");
   ObjectDelete("FiboDn");
   ObjectDelete("FiboIn");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(InnerFibs)
	{
		if(ObjectFind("FiboIn") == -1)
			ObjectCreate("FiboIn",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_D1*60,LoPrice);
		else
		{
			ObjectSet("FiboIn",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboIn",OBJPROP_TIME1, StartTime+PERIOD_D1*60);
			ObjectSet("FiboIn",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboIn",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboIn",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboIn",OBJPROP_FIBOLEVELS,21);
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+0,-2.00);	ObjectSetFiboDescription("FiboIn",0,"(Support 5)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+1,-1.75);	ObjectSetFiboDescription("FiboIn",1,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+2,-1.50);	ObjectSetFiboDescription("FiboIn",2,"(Support 4)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+3,-1.25);	ObjectSetFiboDescription("FiboIn",3,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+4,-1.00);	ObjectSetFiboDescription("FiboIn",4,"(Support 3)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+5,-0.75);	ObjectSetFiboDescription("FiboIn",5,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+6,-0.50);	ObjectSetFiboDescription("FiboIn",6,"(Support 2)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+7,-0.25);	ObjectSetFiboDescription("FiboIn",7,"(Lowest Breakout TP1)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+8,0.00);	ObjectSetFiboDescription("FiboIn",8,"(Lowest Price)  -  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+9,0.25);	ObjectSetFiboDescription("FiboIn",9,"(Sellers Balance)  -  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+10,0.50);	ObjectSetFiboDescription("FiboIn",10,"(Buyers Sellers Balance) -  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+11,0.75);	ObjectSetFiboDescription("FiboIn",11,"(Buyers Balance)  -  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+12,1.00);	ObjectSetFiboDescription("FiboIn",12,"(Highest Price)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+13,1.25);	ObjectSetFiboDescription("FiboIn",13,"(Highest Breakout TP1)%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+14,1.50);	ObjectSetFiboDescription("FiboIn",14,"(Resistance 2)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+15,1.75);	ObjectSetFiboDescription("FiboIn",15,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+16,2.0);	ObjectSetFiboDescription("FiboIn",16,"(Resistance 3)  -  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+17,2.25);	ObjectSetFiboDescription("FiboIn",17,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+18,2.50);	ObjectSetFiboDescription("FiboIn",18,"(Resistance 4)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+19,2.75);	ObjectSetFiboDescription("FiboIn",19,"%$");
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+20,3.00);	ObjectSetFiboDescription("FiboIn",20,"(Resistance 5)  -  %$");
   	ObjectSet("FiboIn",OBJPROP_RAY,true);
   	ObjectSet("FiboIn",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboIn");
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_D1,shift);
	LoPrice		= iLow (NULL,PERIOD_D1,shift);
	StartTime	= iTime(NULL,PERIOD_D1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
	}

	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

