//+------------------------------------------------------------------+
//|                                                      KG MACD.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  Lime
#property  indicator_color2  Lime
#property  indicator_color3  Lime
#property  indicator_color4  White
#property  indicator_color5  Blue
//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
extern int Periode=24;
int MA_Methode=0;
int Price_Type=6;
string tanda;
string tanda1;
string tanda2;
string tanda3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT); 
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE,0,2);
   IndicatorDigits(Digits+2);
   SetIndexDrawBegin(0,38);
   SetIndexDrawBegin(1,38);
   SetIndexDrawBegin(2,38);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer4);   
   SetIndexBuffer(1,ExtBuffer3);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer1);
   SetIndexBuffer(4,ExtBuffer0);
//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Accelerator/Decelerator Oscillator                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,middle,upper,lower,close,sma_middle,middle1;
   double stochmain,stochsign;
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
   {
      ExtBuffer0[i]=iClose(NULL,0,i)-iMA(NULL,0,Periode,0,MA_Methode,Price_Type,i);
      ExtBuffer1[i]=iOpen(NULL,0,i)-iMA(NULL,0,Periode,0,MA_Methode,Price_Type,i);
   }
   //---- dispatch values between 2 buffers
   for(i=0; i<limit; i++)
   {
      ExtBuffer2[i]=iMAOnArray(ExtBuffer0,Bars,Periode,0,MA_Methode,i);
      ExtBuffer3[i]=iBandsOnArray(ExtBuffer0,Bars,Periode,1,0,MODE_UPPER,i);
      ExtBuffer4[i]=iBandsOnArray(ExtBuffer0,Bars,Periode,1,0,MODE_LOWER,i);
   }
      
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i]; 
      prev=ExtBuffer1[i];
      middle=ExtBuffer2[i]; 
      middle1=ExtBuffer2[i+1]; 
      upper=ExtBuffer3[i]; 
      lower=ExtBuffer4[i];
      close=iClose(NULL,0,i);
      sma_middle=iMA(NULL,0,Periode,0,MA_Methode,Price_Type,i);
       
       if(current>prev)  {tanda="CROSS UP";}
       if(current<prev)  {tanda="CROSS DOWN";}
       if(current==prev)  {tanda="FLAT";}
       
       if(middle>middle1)  {tanda2="UP";}
       if(middle<middle1)  {tanda2="DOWN";}
       if(middle==middle1)  {tanda2="FLAT";}
       
       if(current>middle && close>sma_middle)  {tanda1="TRENDING UP";}
       if(current<middle && close<sma_middle)  {tanda1="TRENDING DOWN";}
       if( (current>middle && close<sma_middle) || (current<middle && close>sma_middle) ) {tanda1="SIDEWAY";}
       
       if(current>upper)  {tanda3="UBNORMAL_UP";}
       if(current<lower)  {tanda3="UBNORMAL_DOWN";}
       if((current>=lower && current<=upper))  {tanda3="NORMAL";}
       
       IndicatorShortName("KG MACD ("+Periode+")  ["+tanda+"]  "+tanda2+"  "+tanda3+"  "+tanda1);
     }
   //---- done
   return(0);
  }
//+------------------------------------------------------------------+

