//+------------------------------------------------------------------+
//|                                                      KG MACD.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  Black
#property  indicator_color2  MediumBlue
#property  indicator_color3  Red
#property  indicator_color4  Lime
#property  indicator_color5  Black
#property  indicator_color6  Lime
#property  indicator_color7  Lime
//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];
double     ExtBuffer6[];
extern double Periode=24;
extern int MA_Methode=0;
extern int Price_Type=0;
string tanda;
string tanda1;
string tanda2;
string tanda3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,2);
   SetIndexStyle(3,DRAW_LINE,0,2);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
   IndicatorDigits(Digits+2);
   SetIndexDrawBegin(0,38);
   SetIndexDrawBegin(1,38);
   SetIndexDrawBegin(2,38);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexBuffer(5,ExtBuffer5);
   SetIndexBuffer(6,ExtBuffer6);
//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Accelerator/Decelerator Oscillator                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,smoth1,smoth2,upper,lower;
   double stochmain,stochsign;
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      ExtBuffer4[i]=iClose(NULL,0,i)-iMA(NULL,0,Periode,0,MA_Methode,Price_Type,i);
   //---- dispatch values between 2 buffers
   for(i=0; i<limit; i++)
   {
      ExtBuffer3[i]=iMAOnArray(ExtBuffer4,Bars,Periode,0,MA_Methode,i);
      ExtBuffer5[i]=iBandsOnArray(ExtBuffer4,Bars,Periode,1,0,MODE_UPPER,i);
      ExtBuffer6[i]=iBandsOnArray(ExtBuffer4,Bars,Periode,1,0,MODE_LOWER,i);
   }
      
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer4[i]; 
      prev=ExtBuffer4[i+1];
      smoth1=ExtBuffer3[i];
      smoth2=ExtBuffer3[i+1];
      upper=ExtBuffer5[i];
      lower=ExtBuffer6[i];
      
      if(current>0) up=true;
      if(current<0) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
       ExtBuffer0[i]=current;
       
       if(current>prev)  {tanda="UP";}
       if(current<prev)  {tanda="DOWN";}
       if(current==prev)  {tanda="FLAT";}
       
       if(current>0)  {tanda1="UP";}
       if(current<0)  {tanda1="DOWN";}
       if(current==0)  {tanda1="FLAT";}
       
       if(smoth1>smoth2)  {tanda2="UP";}
       if(smoth1<smoth2)  {tanda2="DOWN";}
       if(smoth1==smoth2)  {tanda2="FLAT";}
       
       if(current>upper)  {tanda3="TRENDING UP";}
       if(current<lower)  {tanda3="TRENDING DOWN";}
       if(current<upper && current>lower)  {tanda3="CONSOLIDATION";}
              
       IndicatorShortName("MACD [Ripple: "+tanda+"] [Wave: "+tanda1+"] [Smothing: "+tanda2+"] "+tanda3);
     }
   //---- done
   return(0);
  }
//+------------------------------------------------------------------+

