//+------------------------------------------------------------------+
//|                                                 Buyer Seller.mq4 |
//|                                      Copyright  2009, wiedstone |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, wiedstone"
#property link      ""

#property indicator_chart_window
extern string Note_1          = "Kperiod dan semuanya tidak usah diisi";
extern int    Kperiod         =24;
extern int    DPeriod         =1;
extern int    Slowing         =1;
extern int    MA_Stc_Method   =MODE_SMA;
extern int    Price_Field     =0;//0=High/Low;1=Close/Close
extern int    MA_Stc_Mode     =MODE_MAIN;

int KperiodH4,KperiodH8,KperiodD1,KperiodW1,KperiodMN1,Kperiod4MN,KperiodY1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  getPeriod();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----

   double   Stoch_H4   =iStochastic(NULL,0,KperiodH4,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_H8   =iStochastic(NULL,0,KperiodH8,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_D1   =iStochastic(NULL,0,KperiodD1,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_W1   =iStochastic(NULL,0,KperiodW1,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_MN1  =iStochastic(NULL,0,KperiodMN1,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_4MN  =iStochastic(NULL,0,Kperiod4MN,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   double   Stoch_Y1   =iStochastic(NULL,0,KperiodY1,DPeriod,Slowing,MA_Stc_Method,Price_Field,MA_Stc_Mode,0);
   Comment ("--------------------------------------------"+ "\n" + 
            "Simple Buyers-Sellers Strength :" + "\n" + 
            "Valid in TF M15 - H1 only !"     + "\n" + 
            "--------------------------------------------"+ "\n" +
            "Buyers Strength 4-Hourly: " + DoubleToStr(Stoch_H4,1) + " %" + "\n" + 
            "Sellers Strength 4-Hourly: " + DoubleToStr(MathAbs(Stoch_H4-100),1) + " %" + "\n" + 
            "--------------------------------------------"+ "\n" +
            "Buyers Strength 8-Hourly: " + DoubleToStr(Stoch_H8,1) + " %" + "\n" + 
            "Sellers Strength 8-Hourly: " + DoubleToStr(MathAbs(Stoch_H8-100),1) + " %" + "\n" + 
            "--------------------------------------------"+ "\n" +
            "Buyers Strength Daily: " + DoubleToStr(Stoch_D1,1) + " %" + "\n" + 
            "Sellers Strength Daily: " + DoubleToStr(MathAbs(Stoch_D1-100),1) + " %" + "\n" + 
            "--------------------------------------------"+ "\n" +
            "Buyers Strength Weekly: " + DoubleToStr(Stoch_W1,1) + " %" + "\n" + 
            "Sellers Strength Weekly: " + DoubleToStr(MathAbs(Stoch_W1-100),1) + " %" + "\n" + 
            "--------------------------------------------"+ "\n" +
            "Buyers Strength Monthly: " + DoubleToStr(Stoch_MN1,1) + " %" + "\n" + 
            "Sellers Strength Monthly: " + DoubleToStr(MathAbs(Stoch_MN1-100),1) + " %" + "\n" + 
            //"Buyers Strength 4-Monthly: " + DoubleToStr(Stoch_4MN,1) + " %" + "\n" + 
            //"Sellers Strength 4-Monthly: " + DoubleToStr(MathAbs(Stoch_4MN-100),1) + " %" + "\n" + 
            //"Buyers Strength Yearly: " + DoubleToStr(Stoch_Y1,1) + " %" + "\n" + 
           // "Sellers Strength Yearly: " + DoubleToStr(MathAbs(Stoch_Y1-100),1) + " %" + "\n" + 
            "--------------------------------------------"
             );
            
//----
   return(0);
  }
//+------------------------------------------------------------------+
void getPeriod(){
 switch(Period())
 {
  case PERIOD_M1: KperiodH4=240;KperiodH8=480;KperiodD1=1440;KperiodW1=0;KperiodMN1=0;Kperiod4MN=0;KperiodY1=0;return;
  case PERIOD_M5: KperiodH4=48;KperiodH8=96;KperiodD1=288;KperiodW1=1440;KperiodMN1=0;Kperiod4MN=0;KperiodY1=0;return;
  case PERIOD_M15: KperiodH4=16;KperiodH8=32;KperiodD1=96;KperiodW1=480;KperiodMN1=1920;Kperiod4MN=0;KperiodY1=0;return;
  case PERIOD_M30: KperiodH4=8;KperiodH8=16;KperiodD1=48;KperiodW1=240;KperiodMN1=960;Kperiod4MN=0;KperiodY1=0;return;
  case PERIOD_H1: KperiodH4=4;KperiodH8=8;KperiodD1=24;KperiodW1=120;KperiodMN1=480;Kperiod4MN=1920;KperiodY1=0;return;
  case PERIOD_H4: KperiodH4=0;KperiodH8=2;KperiodD1=6;KperiodW1=30;KperiodMN1=120;Kperiod4MN=480;KperiodY1=1440;return;
  case PERIOD_D1: KperiodH4=0;KperiodH8=0;KperiodD1=0;KperiodW1=5;KperiodMN1=20;Kperiod4MN=80;KperiodY1=240;return;
  case PERIOD_W1: KperiodH4=0;KperiodH8=0;KperiodD1=0;KperiodW1=0;KperiodMN1=4;Kperiod4MN=16;KperiodY1=48;return;
  case PERIOD_MN1: KperiodH4=0;KperiodH8=0;KperiodD1=0;KperiodW1=0;KperiodMN1=0;Kperiod4MN=12;KperiodY1=3;return;
 }
 
}